% Define environment (functions, gradients etc...)
GivenEnv

% Define parameters
max_iter = 1000; % Maximum iterations
tol = 0.001; % Tolerance

% Point x0 = (1, 1)
% =========================================================================
point = 1;
x0 = [5, -5]';
point_str = "[" + x0(1) + ", " + x0(2) + "]";
f = fun(x0);
gf = grad_fun(x0);
hf = hessian_fun(x0);
fprintf('Initial point (%d, %d), f = %f, grad = [%f;%f], hessian = [%f %f ; %f %f]=> Method applicable\n', x0, f, gf, hf);


k = zeros(100, 1);
j = 1;
n = linspace(0.1, 1.5, 100);
for g = n
    gamma_fixed_step = g;
    [~, ~, k(j)] = method_SteepDesc(fun, grad_fun, x0, tol, max_iter, 'fixed');
    j = j + 1;
end
plotItersOverGamma(n, k, "Iteration for different $\gamma$ values", "figures/StDes_Iter_o_gamma_" + point + ".png");

for g=[0.1, 0.3, 3, 5]
    gamma_fixed_step = g;

    [x_fixed, f_fixed, kk] = method_SteepDesc(fun, grad_fun, x0, tol, max_iter, 'fixed');
    fprintf('Fixed step g=%f:     Initial point (%f, %f), steps:%d, Final (x1,x2)=(%f, %f), f(x1,x2)=%f\n', g, x0, kk, x_fixed(:, end), f_fixed(end));
    if g <= 1
        plotPointsOverContour(x_fixed, fun, XSetLimmits(1, :), XSetLimmits(2, :), 100, point_str + ": Steepest descent $\gamma$ = " + gamma_fixed_step, "figures/StDes_gamma_" + g + ".png");
    else
        plotPointsOverContour(x_fixed, fun, [-500, 500], [-500, 500], 100, point_str + ": Steepest descent $\gamma$ = " + gamma_fixed_step, "figures/StDes_gamma_" + g + ".png");
    end
end

